<?php

	/*
	*	Gekko - Open Source Web Development Framework
	*	------------------------------------------------------------------------
	*	Copyright (C) 2004-2005, J. Carlos Nieto <xiam@users.sourceforge.net>
	*	This program is Free Software.
	*
	*	@package	Gekko
	*	@license	http://www.gnu.org/copyleft/gpl.html GNU/GPL License 2.0
	*	@author		J. Carlos Nieto <xiam@users.sf.net>
	*	@version	CVS: $Id:$
	*	@link		http://gekkoware.sourceforge.net
	*/

	define ("IN-GEKKO", true);

	require_once "../../conf.php";
	require_once GEKKO_ROOT."lib/core.lib.php";
	require_once GEKKO_ROOT."lib/file.lib.php";
	require_once GEKKO_ROOT."lib/image.lib.php";
	require_once GEKKO_ROOT."modules/categories/main.lib.php";

	db_init();

	require_once GEKKO_ROOT."lib/auth.inc.php";

	if (!gauth("categories")) abort(accessDenied());

	gpGet("action", 1);
	gpGet("id", 1);
	gpGet("return", 1);

	switch ($action) {
		case "delete":
			execWithEach($id, "deleteCategory");
		break;
		case "disable":
			categorySetStatus($id, 0);
		break;
		case "enable":
			categorySetStatus($id, 1);
		break;
		case "create":

			gpGlobalize("icon, category, description, status, auth_access");

			requireVars($category);

			if ($_POST["remote_file"] || $_FILES["local_file"]["size"]) {
				$thumb = file_get("local_file", "remote_file");
				if ($thumb) {
					$thumb = mkthumbnail($thumb["abs_loc"], "50x50");
					$icon = $thumb["url"];
				}
			}

			// checking for duplicated category name
			$db->query ("SELECT ID FROM ".db_table("category")." WHERE Category = '".$category."'", __FILE__, __LINE__);
			if ($db->num_rows()) {
				abort(_l("E_DUPLICATED_CATEGORY"));
			}

			// inserting into database
			$db->query ("
			INSERT INTO ".db_table("category")."
				(
					ID,
					Icon,
					Category,
					Description,
					Status,
					auth_Access
				)
					VALUES
				(
					'".$db->free_id("category")."',
					'{$icon}',
					'{$category}',
					'{$description}',
					'{$status}',
					'{$auth_access}'
				)
			", __FILE__, __LINE__);

			slog("categories: created '$category'", "actions", 1);
		break;
		case "edit":

			gpGlobalize("icon, category, description, status, auth_access");

			requireVars($id, $category);

			if ($_POST["remote_file"] || $_FILES["local_file"]["size"]) {
				$thumb = file_get("local_file", "remote_file");

				if ($thumb) {
					// creating a new icon
					$thumb = mkthumbnail($thumb["abs_loc"], "50x50");
					$icon = $thumb["url"];

					// deleting old icon
					$orig = db_get_field("category", $id, "Icon");
					if (file_exists($opath = GEKKO_ROOT.$orig)) {
						@unlink($opath);
					}
				}
			}

			$db->query ("
				UPDATE ".db_table("category")." SET
					Icon = '{$icon}',
					Category = '{$category}',
					Description = '{$description}',
					Status = '{$status}',
					auth_Access = '{$auth_access}'
				WHERE ID = '{$id}'
			", __FILE__, __LINE__);

		break;
		default:
			abort(_l("E_UNKNOWN_ACTION"));
		break;
	}

	redirect($return ? $return : $_SERVER["HTTP_REFERER"]);

	db_exit();
?>